package software.eskimo.capacitor.sockets;

import android.util.Log;
import java.util.ArrayList;
import java.util.List;

public class Sockets implements SocketDelegate {

    private List<SocketConnection> sockets = new ArrayList<>();
    private SocketsPlugin plugin;

    public Sockets(SocketsPlugin plugin) {
        this.plugin = plugin;
    }

    @Override
    public void didChangeState(String socketId, String state) {
        plugin.notifyStateChange(socketId, state);
    }

    @Override
    public void didReceiveMessage(String socketId, String message) {
        Log.e("Sockets", "Received message: " + message);
        plugin.notifyMessageReceived(socketId, message);
    }

    public SocketConnection create(String id, String host, int port, boolean useTLS, boolean acceptInvalidCertificates) {
        SocketConnection socket = new SocketConnection(id, host, port, useTLS, acceptInvalidCertificates);
        socket.setDelegate(this);
        sockets.add(socket);
        return socket;
    }

    public void connect(String id) {
        for (SocketConnection socket : sockets) {
            if (socket.id.equals(id)) {
                socket.connect();
                break;
            }
        }
    }

    public void send(String id, String message) {
        for (SocketConnection socket : sockets) {
            if (socket.id.equals(id)) {
                socket.send(message);
                break;
            }
        }
    }

    public void disconnect(String id) {
        for (SocketConnection socket : sockets) {
            if (socket.id.equals(id)) {
                socket.disconnect();
                break;
            }
        }
    }
}
